#import <QCObject.h>
#import <QCRegion.h>

@interface QCImage : QCObject
{
    id <QCImageProvider> _provider;
    NSAffineTransform *_transformation;
    QCRegion *_domainOfDefinition;
    void *_unused2[4];
}

+ (void)initialize;
- (id)initWithProvider:(id)fp8 options:(id)fp12;
- (void)dealloc;
- (id)initWithImage:(id)fp8;
- (id)provider;
- (BOOL)isInfinite;
- (NSRect)bounds;
- (id)domainOfDefinition;
- (id)transformation;
- (id)createCroppedImageWithRect:(NSRect)fp8;
- (id)_createTransformedImage:(QCImageTransform *)fp8 definition:(id)fp12;
- (id)createTranslatedImageByX:(float)fp8 Y:(float)fp12;
- (id)createScaledImageByX:(float)fp8 Y:(float)fp12;
- (id)createScaledImageByX:(float)fp8 Y:(float)fp12 fromX:(float)fp16 Y:(float)fp20;
- (id)createRotatedImageByDegrees:(float)fp8;
- (id)createRotatedImageByDegrees:(float)fp8 aroundX:(float)fp12 Y:(float)fp16;
- (id)createTransformedImage:(id)fp8;
- (id)createPixelBufferForManager:(id)fp8 withFormat:(id)fp12 bounds:(NSRect)fp16 colorSpace:(struct CGColorSpace *)fp32 options:(id)fp36;
- (id)createTextureBufferForManager:(id)fp8 withFormat:(id)fp12 target:(unsigned int)fp16 bounds:(NSRect)fp20 colorSpace:(struct CGColorSpace *)fp36 options:(id)fp40;
- (id)createRepresentationOfType:(id)fp8 forManager:(id)fp12 withOptions:(id)fp16;
- (id)description;

@end

@interface QCImage (ExporterRegistry)
+ (void)registerImageExporterClass:(Class)fp8;
+ (id)imageExporterClasses;
+ (unsigned int)imageExporterRegistryTimestamp;
@end

@interface QCImage (ProviderRegistry)
+ (void)registerImageProviderClass:(Class)fp8;
+ (id)imageProviderClasses;
+ (id)createImageWithSource:(id)fp8 options:(id)fp12;
@end

@interface QCImage (QCExporter_NSImage)
- (id)createNSImageForManager:(id)fp8 withOptions:(id)fp12;
- (id)createNSBitmapImageRepForManager:(id)fp8 withOptions:(id)fp12;
@end

@interface QCImage (QCProvider_NSImage)
- (id)_initWithNSImageSource:(id)fp8 options:(id)fp12;
- (id)initWithNSImage:(id)fp8 options:(id)fp12;
- (id)initWithNSBitmapImageRep:(id)fp8 options:(id)fp12;
@end

@interface QCImage (QCProvider_CoreVideo)
- (id)initWithCVImageBuffer:(struct __CVBuffer *)fp8 options:(id)fp12;
@end

@interface QCImage (QCExporter_CoreVideo)
- (struct __CVBuffer *)createCVPixelBufferForManager:(id)fp8 withOptions:(id)fp12;
- (struct __CVBuffer *)createCVOpenGLBufferForManager:(id)fp8 withOptions:(id)fp12;
@end

// declared publicly?
/*@interface QCImage (QCExporter_CoreVideo)
- (struct __CVBuffer *)createCVPixelBufferForManager:(id)fp8 withOptions:(id)fp12;
- (struct __CVBuffer *)createCVOpenGLBufferForManager:(id)fp8 withOptions:(id)fp12;
@end*/

@interface QCImage (QCProvider_CoreText)
- (id)initWithTextRenderer:(id)fp8 options:(id)fp12;
- (id)initWithString:(id)fp8 attributes:(id)fp12 layoutSize:(NSSize)fp16 options:(id)fp24;
@end

@interface QCImage (QCProvider_CoreImage)
- (id)initWithCIImage:(id)fp8 options:(id)fp12;
- (id)CIImageRepresentation;
@end

@interface QCImage (QCExporter_CoreImage)
- (id)createCIImageForManager:(id)fp8 withOptions:(id)fp12;
@end

@interface QCImage (QCProvider_CoreGraphics)
+ (id)createAllImagesFromData:(id)fp8 options:(id)fp12;
- (id)initWithPDFDocument:(struct CGPDFDocument *)fp8 pageNumber:(unsigned int)fp12 options:(id)fp16;
- (id)initWithCGPath:(struct CGPath *)fp8 options:(id)fp12;
- (id)initWithCGLayer:(struct CGLayer *)fp8 options:(id)fp12;
- (id)initWithCGImage:(struct CGImage *)fp8 options:(id)fp12;
- (id)initWithCGImageSource:(struct CGImageSource *)fp8 imageIndex:(unsigned int)fp12 options:(id)fp16;
- (id)initWithData:(id)fp8 options:(id)fp12;
- (id)initWithFile:(id)fp8 options:(id)fp12;
- (id)initWithURL:(id)fp8 options:(id)fp12;
@end

@interface QCImage (ImageFiles)
+ (id)imageFileExtensions;
+ (id)imageFileTypes;
@end

@interface QCImage (QCExporter_CoreGraphics)
- (struct CGImage *)createCGImageForManager:(id)fp8 withOptions:(id)fp12;
- (id)createImageDataForManager:(id)fp8 withOptions:(id)fp12;
- (BOOL)writeToFile:(id)fp8 forManager:(id)fp12 withOptions:(id)fp16;
- (BOOL)writeToURL:(id)fp8 forManager:(id)fp12 withOptions:(id)fp16;
@end

@interface QCImage (QCImageBufferProvider)
- (id)initWithQCImageBuffer:(id)fp8 options:(id)fp12;
@end

@interface QCImage (NSCoding) <NSCoding>
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
@end

